function dataOut = TCPRead(instrument, numBytes, timeout)

numBytesAvailable = 0;
timedOut = 0;
totalBytesRead = 0;
dataOut = uint8([]);
tic;
%Read all bytes available in the TCP stream buffer each time through the
%loop, until you get to the total number of bytes desired.
while(totalBytesRead < numBytes)
    if(toc > timeout)
        errorOut = 'h.API: Instrument did not return valid response within specified timeout';
        error(errorOut);
        timedOut = 1;
        break;
    end
    numBytesRemaining = numBytes-totalBytesRead;
    numBytesAvailable = instrument.BytesAvailable;
    if(numBytesRemaining < numBytesAvailable)
        bytesToRead = numBytesRemaining;
    else
        bytesToRead = numBytesAvailable;
    end
    if bytesToRead > 0
        newData = fread(instrument, double(bytesToRead));
        totalBytesRead = totalBytesRead + bytesToRead;
        dataOut = [dataOut; newData];
    end
end
