%This will acquire data from a single channel, apply the calibration scale
%and offset, and then plot the data.

address = '10.0.41.3';
channel = 1;

hyperionInstrument = hCOMMOpenConnection(address, 'commandPort', 1);


[offset, scale] = hACQGetPowerCalibrationInfo(hyperionInstrument);

[spectrum, header] = hACQGetSpectrum(hyperionInstrument, channel, 1);

scaledSpectrum = double(spectrum)/double(scale(channel)) + double(offset(channel));

wavelengths = double(header.startWavelength) + double(0:header.numPoints-1)*header.wavelengthIncrement;
plot(wavelengths,scaledSpectrum)

xlabel('Wavelength (nm)')
ylabel('Optical Power (dBm)')

hCOMMCloseConnection(hyperionInstrument);