%This will enable spectrum data streaming, open the streaming port, and then
%stream as many scans as specified.

address = '10.0.41.3';
scanRate = 10;
spectrumStreamingDivider = 1;
numberOfScans = 10;
channelList = [1,5];
hyperionInstrument = hCOMMOpenConnection(address, 'commandPort', 1);

%Setting the laser scan speed can take a few seconds.  Uncomment this only
%if you need to change the scan rate.
%response = hACQSetLaserScanSpeed(hyperionInstrument, scanRate);
%disp(char(response.message'))

%Set the streaming divider to determine how the spectra are returned.  If
%divder = 1, then every spectrum is returned.
response = hACQSetSpectrumStreamingDivider(hyperionInstrument, spectrumStreamingDivider);
disp(char(response.message'))
%Enable spectrum streaming
response = hACQSetEnableSpectrumDataStreaming(hyperionInstrument, 1);
disp(char(response.message'))
%Make connection to the streaming port
hyperionInstrumentSpectrumStreamer = hCOMMOpenConnection(address, 'spectrumStream', 1);
serialNumbers = zeros(1, numberOfScans);
for scan = 1:numberOfScans
    [spectrum, header] = hACQGetStreamingSpectrum(hyperionInstrumentSpectrumStreamer,channelList,1);
    %do other processing here to analyze or plot the data, or save to disk.
    serialNumbers(scan) = double(header.serialNumber);
end
if max(diff(serialNumbers)) == 1
    disp('No dropped samples detected')
end
%Disable streaming
response = hACQSetEnableSpectrumDataStreaming(hyperionInstrument, 0);
%Close both ports
hCOMMCloseConnection(hyperionInstrumentSpectrumStreamer);
hCOMMCloseConnection(hyperionInstrument);