function uintData = ByteArrayToUInt(byteArray,numBitsOut)
%function uintData = ByteArrayToUint(byteArray,numBitsOut)

numBytesOut = numBitsOut/8;

if abs(numBytesOut - floor(numBytesOut)) > 0.01
    errorOut = 'h.API:  numBitsOut must be multiple of 8';
    error(errorOut);
elseif (numBytesOut < 1) || (numBytesOut > 8)
    errorOut = 'h.API:  numBitsOut must be 8, 16, 32 or 64';
    error(errorOut);
end
    
toUint = 2.^[0:(numBytesOut-1)];

try
    byteArray = reshape(byteArray,numBytesOut,[]);
catch
    errorOut = 'h.API:  Number of bytes is not a multiple of desired output length';
    error(errorOut);
end

uintData = toUint*double(byteArray);

convertString = sprintf('uint%d(uintData)',numBitsOut);
uintData = eval(convertString);
