function byteArrayOut = PackBytes(uintVal,endianness)
%byteArrayOut = PackBytes(uintVal,endianness)
%This takes any size of unsigned integer and converts it into a byte array
BIG_ENDIAN = 0;
LITTLE_ENDIAN = 1;
byteCount = 0;
switch class(uintVal)
    case 'uint8'
        byteArrayOut = uintVal;
        byteCount = 1;
    case 'uint16'
        byteCount = 2;
    case 'uint32'
        byteCount = 4;
    case 'uint64'
        byteCount = 8;
    otherwise
        errorStr = 'uintVal must be an unsigned integer type'
        error(errorStr);
end

if byteCount > 1;
    if endianness == BIG_ENDIAN;
        bytes = 1:byteCount;
    else
        bytes = byteCount:-1:1;
    end
    index = 1;
    for val = uintVal
        for byte = bytes
            shift = (byteCount - byte)*8;
            byteArrayOut(index) = ...
                uint8(bitand(bitshift(val,-shift),255));
            index = index + 1;
        end
    end
end